with Ada.Finalization;
package Log is

  procedure Note(S : in String);
  -- Output time stamp (Ada.Calendar.Seconds) and S to file "log".
  -- Create such a file, or append if one already exists.
  -- Ada.Finalization handles creation and final closing.
  -- Task safe.

private
  type Log_Objects is new Ada.Finalization.Limited_Controlled with null record;
  procedure Initialize(X : in out Log_Objects);
  procedure Finalize(X : in out Log_Objects);

end Log;
