with Ada.Command_Line,
     Ada.Text_Io,
     Urls,
     Workers;

procedure Finder is
--   use Ada.Characters.Handling;
--   use type Claw.Sockets.Network_Address_Type;
  Port_Exception_File_Name: constant String := "Finder-Port-Exceptions";
  Usage1  : constant String
    := "usage:Finder www.xxx.yyy[/a/b] [findref file] > progress report";
  Usage2  : constant String
    := " size+date of each url referenced -> 'found'";
  Usage3  : constant String
    := "References to URLs in the findref file, if any, will be noted";
  Usage4  : constant String
    := "optional file "
       & Port_Exception_File_Name
       & " may list www.a.b:123 style special ports";
  subtype Url_Strings is String(1 .. 900); -- max expected url size
  Result_File: Ada.Text_Io.File_Type;
begin
  Ada.Text_Io.Create(Result_File, Ada.Text_Io.Out_File, "found");
  if Ada.Command_Line.Argument_Count in 1 .. 2 then
    Ada.Text_Io.Put_Line(Result_File, "%Start //"
                                      & Ada.Command_Line.Argument(1));
    Urls.Create_Port_Exception_List(Port_Exception_File_Name);

    Urls.Database.Start("//" & Ada.Command_Line.Argument(1));
    for I in Workers.Worker'range loop
      Workers.Worker(I).Start(I);
    end loop;

    -- Now just hang around waiting for workers to finish
    -- Dump to be Accept-ed
    Urls.Database.Dump(Result_File);
  else
    Ada.Text_Io.Put_Line(Usage1); -- to stdout for viewing
    Ada.Text_Io.Put_Line(Usage2);
    Ada.Text_Io.Put_Line(Usage3);
    Ada.Text_Io.Put_Line(Usage4);
  end if;

end Finder;
