with Ada.Text_IO,
     Claw;

package Statistics is

  -- This package must only be used by one single task at a time.

  -- Finished_One will periodically display a progress report to the operator.

  procedure Set_Name(Name : in String);
  -- Set the name of the operator's monitoring window.
  -- May raise Claw.Not_Valid_Error if the window has been closed.

  procedure Finished_One (Size : in Claw.DWord; --finished processing some url
                          Foreign : in Boolean;
                          Failed : in Boolean;
                          Scanned : in Boolean;
                          URL_String : in String;
                          Second_Try : in Boolean;
                          URL_Count : in Claw.DWord);

  procedure Increment_Links_Scanned;
  procedure Increment_Old_Domain_Links;
  procedure Increment_AdaIC_Links;
  procedure Increment_Bad_Links;

  function Kill_Request return Boolean; -- True iff op wants to stop run

  procedure Print (Result_File : in Ada.Text_IO.File_Type);
  -- dump statistics to Result_File

private
    procedure Display(URL_Count : in Claw.DWord);

end Statistics;
